//////////////////////////////////////////////////////////////////////
//
//  ACROBAT.PRG
//
//////////////////////////////////////////////////////////////////////

#INCLUDE "dcdialog.CH"

// Include the Automation Support Library
#PRAGMA LIBRARY( "ASCOM10.LIB" )

// Include the UI Extension Library (required for "XbpFileDialog")
#PRAGMA LIBRARY( "XPPUI2.LIB" )

#include "APPEVENT.CH"
#include "activex.ch"



// Enumeration WdSaveFormat
#DEFINE wdFormatDocument	        0	&& Microsoft Office Word format.
#DEFINE wdFormatDocument97	        0	&& Microsoft Word 97 document format.
#DEFINE wdFormatTemplate	        1	&& Word template format.
#DEFINE wdFormatTemplate97	        1	&& Word 97 template format.
#DEFINE wdFormatText            	2	&& Microsoft Windows text format.
#DEFINE wdFormatTextLineBreaks  	3	&& Windows text format with line breaks preserved.
#DEFINE wdFormatDOSText         	4	&& Microsoft DOS text format.
#DEFINE wdFormatDOSTextLineBreaks	5	&& Microsoft DOS text with line breaks preserved.
#DEFINE wdFormatRTF	                6	&& Rich text format (RTF).
#DEFINE wdFormatEncodedText	        7	&& Encoded text format.
#DEFINE wdFormatUnicodeText	        7	&& Unicode text format.
#DEFINE wdFormatHTML	                8	&& Standard HTML format.
#DEFINE wdFormatWebArchive	        9	&& Web archive format.
#DEFINE wdFormatFilteredHTML	        10	&& Filtered HTML format.
#DEFINE wdFormatXML	                11	&& Extensible Markup Language (XML) format.
#DEFINE wdFormatXMLDocument	        12	&& XML document format.
#DEFINE wdFormatXMLDocumentMacroEnabled	13	&& XML document format with macros enabled.
#DEFINE wdFormatXMLTemplate	        14	&& XML template format.
#DEFINE wdFormatXMLTemplateMacroEnabled	15	&& XML template format with macros enabled.
#DEFINE wdFormatDocumentDefault	        16	&& Word default document file format. For Microsoft Office Word 2007, this is the DOCX format.
#DEFINE wdFormatPDF	                17	&& PDF format.
#DEFINE wdFormatXPS	                18	&& XPS format.



// Enumeration WdExportFormat
#DEFINE wdExportFormatPDF	17	&& Export document into PDF format.
#DEFINE wdExportFormatXPS	18	&& Export document into XML Paper Specification (XPS) format.


* -------------

PROCEDURE Main()

LOCAL GetList[0], oAcrobat, oStatusBar, oToolBar, oStatic, oDlg, ;
      GetOptions

Local cPath := ( CurDrive() + ':\' + CurDir() + '\' )
Local cFile := 'ActiveX test.doc'

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE 500, 500 PIXEL ;
      OBJECT oStatic

@ 0,0 DCACTIVEXCONTROL oAcrobat ;
   SIZE 500, 500 PIXEL ;
   CLSID "{CA8A9780-280D-11CF-A24D-444553540000}" ;
   PARENT oStatic ;
   EVAL {|o|o:setShowToolBar(.t.), ;
            o:setShowScrollBars(.t.)}

DCGETOPTIONS ;
   AUTORESIZE

DCREAD GUI ;
   FIT ;
   OPTIONS GetOptions ;
   TITLE 'Acrobat ActiveX Test' ;
   SETAPPWINDOW ;
   EVAL {|| ShowWordAsPdf( cPath, cFile, oAcrobat ) }

RETURN

*

PROCEDURE AppSys()
RETURN

*

PROCEDURE DbeSys
RETURN

*

***********************
Procedure ShowWordAsPdf( _cPath, _cFile, _oAcrobat )
***********************

Local oWord, oDoc
*
Local cFile := Left( _cFile, ( RAt( '.', _cFile ) - 1 ) )
Local cExt  := SubStr( _cFile, ( RAt( '.', _cFile ) + 1 ) )
*
Local cSaveAsPdf   := ( _cPath + cFile + '-SaveAsPdf.pdf' )
Local cExportAsPdf := ( _cPath + cFile + '-ExportPdf.pdf' )

* dcdebug cFile, cExt, cSaveAsPdf, cExportAsPdf

If File( ( _cPath + _cFile ) )

   oWord := CreateObject( 'Word.Application' )

   If Empty( oWord )
      DCMSGBOX 'Microsoft Word not installed!'
   Else
      FErase( cSaveAsPdf )
      FErase( cExportAsPdf )
      *
*       oWord:visible := .T.
      oWord:visible := .F.
      oWord:documents:open( ( _cPath + _cFile ) )
*       oWord:ActivePrinter := 'PDFCreator'
      oDoc := oWord:ActiveDocument
*       oDoc:PrintOut()   && 'ActiveX test.pdf'
      oDoc:saveas( cSaveAsPdf, wdFormatPDF )
      oDoc:ExportAsFixedFormat( cExportAsPdf, wdExportFormatPDF )
      oDoc:close()
*       oWord:ActivePrinter := 'HP LaserJet 1018'
      oWord:Quit()
      oWord:destroy()

      * * *

*       _oAcrobat:loadFile( ( _cPath + cFile + '.pdf' ) )      && PDFCreator
*       _oAcrobat:loadFile( cSaveAsPdf )
      _oAcrobat:loadFile( cExportAsPdf )

      * * *

   EndIf
Else
   DCMSGBOX ( 'File ' + _cPath + _cFile + ' not found!' )
EndIf

Return

*

// EOF
